/*
 *  ebt_mark
 *
 *	Authors:
 *	Bart De Schuymer <bdschuym@pandora.be>
 *
 *  July, 2002
 *
 */

/* The mark target can be used in any chain,
 * I believe adding a mangle table just for marking is total overkill.
 * Marking a frame doesn't really change anything in the frame anyway.
 */

#include <linux/netfilter_bridge/ebtables.h>
#include <linux/netfilter_bridge/ebt_mark_t.h>
#include <linux/module.h>

static int ebt_target_mark(struct sk_buff **pskb, unsigned int hooknr,
   const struct net_device *in, const struct net_device *out,
   const void *data, unsigned int datalen)
{
	struct ebt_mark_t_info *info = (struct ebt_mark_t_info *)data;

/*vic add begin*/
#if 0	
        unsigned int* q1;
        unsigned int  q;
if ((*pskb)->protocol == __constant_htons(ETH_P_8021Q)) {
    q1 = (unsigned int *)((*pskb)->nh.raw);
        	         	
//printk("in %08x,%08x,%08x\n",*q1,(*q1 & 0xe0000000),(*q1 & 0xe0000000)>>29);        	         	
//printk("mark in 0x%08x/0x%08x out 0x%08x/0x%08x\n",(*q1 & 0xe0000000)>>29,(*pskb)->nfmark,(info->mark&0x0000ff00)>>8,info->mark&0x000000ff);

    q = *q1 & 0xe0000000 ;
//printk("%08x != %08x\n",(q >> 21),info->mark&0x0000ff00);
    if ((q >> 21) != (info->mark&0x0000ff00)) {    
        q = info->mark&0x0000ff00;
        q <<= 21;
        *q1 &= 0x1ffffff;
//        printk(" %08x is filled to %08x\n",q,*q1);
        *q1 |= q ;	
//        printk("802.1Q header 0x%08x\n", *q1);
    }
}
 #endif 
/*vic add end */

	if ((*pskb)->nfmark != info->mark) {
		(*pskb)->nfmark = info->mark;
		(*pskb)->nfcache |= NFC_ALTERED;
	}
	return info->target;
}

static int ebt_target_mark_check(const char *tablename, unsigned int hookmask,
   const struct ebt_entry *e, void *data, unsigned int datalen)
{
	struct ebt_mark_t_info *info = (struct ebt_mark_t_info *)data;

	if (datalen != EBT_ALIGN(sizeof(struct ebt_mark_t_info)))
		return -EINVAL;
	if (BASE_CHAIN && info->target == EBT_RETURN)
		return -EINVAL;
	CLEAR_BASE_CHAIN_BIT;
	if (INVALID_TARGET)
		return -EINVAL;
	return 0;
}

static struct ebt_target mark_target =
{
	.name		= EBT_MARK_TARGET,
	.target		= ebt_target_mark,
	.check		= ebt_target_mark_check,
	.me		= THIS_MODULE,
};

static int __init init(void)
{
	return ebt_register_target(&mark_target);
}

static void __exit fini(void)
{
	ebt_unregister_target(&mark_target);
}

module_init(init);
module_exit(fini);
MODULE_LICENSE("GPL");
