/*****************************************************************************
# <:copyright-gpl 
# Copyright 2004 Broadcom Corp. All Rights Reserved. 
# This program is free software; you can distribute it and/or modify it 
# under the terms of the GNU General Public License (Version 2) as 
# published by the Free Software Foundation. 
# This program is distributed in the hope it will be useful, but WITHOUT 
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
# for more details. 
# You should have received a copy of the GNU General Public License along 
# with this program; if not, write to the Free Software Foundation, Inc., 
# 59 Temple Place - Suite 330, Boston MA 02111-1307, USA. 
# :>
******************************************************************************
//
//  Filename:       syscall.h
//  Author:         Peter T. Tran
//  Creation Date:  12/26/01
//
******************************************************************************
//  Description:
//      Define the global constants, and functions for sysCall utility.
//
*****************************************************************************/

#ifndef __SYS_CALL_H__
#define __SYS_CALL_H__
#include <netinet/in.h>

/********************** Global Functions ************************************/

#define FILE_OPEN_OK			0
#define FILE_OPEN_ERR			-1

#define MNTR_STS_OK			0
#define MNTR_STS_ADSL_DOWN		1
#define MNTR_STS_PPP_AUTH_ERR		2
#define MNTR_STS_PPP_DOWN		3
#define MNTR_STS_OPEN_ERR		4
#define MNTR_STS_DHCPC_PROGRESS  	5
#define MNTR_STS_DHCPC_FAIL   		6
#define MNTR_STS_ADSL_TRAINING		7

#define DHCPC_STS_FAIL           	0
#define DHCPC_STS_SUCCESS        	1
#define DHCPC_FAIL_MAX           	15

// Values for network protocol
#define PROTO_PPPOE			0
#define PROTO_PPPOA			1
#define PROTO_MER			2
#define PROTO_BRIDGE			3
#define PROTO_PPPOE_RELAY	        4
#define PROTO_IPOA			5
#if SUPPORT_ETHWAN
#define PROTO_IPOWAN                    6
#endif
#define PROTO_NONE 			10

#define SYSTEM_APPID       "SystemInfo"
#define SYS_USER_NAME_ID   1
#define SYS_PASSWORD_ID    2
#define SPT_USER_NAME_ID   3
#define SPT_PASSWORD_ID    4
#define USR_USER_NAME_ID   5
#define USR_PASSWORD_ID    6
#define SYS_DFT_GTWY_ID    7
#define SYS_DNS_ID         8
#define SYS_LOG_ID         9
#define SYS_SNMP_ID        10
#define SYS_FLAG_ID        11
/*Start andy porting from 2.21.5*/
#define SYS_DDNS_ID	   	   12 //Andy add to suuport ddns status
#define SYS_HOSTNAME_ID    13 //Andy add to support hostname
#define SYS_DOMAINNAME_ID  14 //Andy add to support domain name
#define SYS_ACTPPPCONN_ID  15 //Andy add to support active ppp connect
#define SYS_FIREWALL_ID_ODM 16 //Wilson add to support enable/disable firewall from web page.
#define SYS_REMOTE_SERVICE_ID 17 //Andy Add to support Remote Access Service
#define SYS_REMOTE_AUTHSER_ID 18 //Andy Add to support Remote Access Service
#define SYS_PRINTERSERVER_ID 19 //Wilson add to support print server
#define SYS_ODM_VOICE_QOS_ID 20

/*==== end ====*/
#define SYS_BRCM_DSP_FXO_ID 	21

/*End andy porting from 2.21.5*/
/*wilson add, 05/30/2005*/
#ifdef BUILD_PPP_DOMAIN_SUFFIX
#define SYS_SUFFIX_ID       22
#endif
/*end of wilson add*/
#ifdef ODM_MULTI_LANG
#define SYS_WEBLANG_ID   23
#endif
#if defined(SUPPORT_SYS_ALG)
#if defined(SUPPORT_SYS_VPN_ALG) || defined(SUPPORT_SYS_SIP_ALG)
#define SYS_ALG_ID       24 
#endif
#endif
#if DM111P || DM111PB || DM111PU || DM111PUB || DM111P_UK || DM111P_TRUE || DM111P_SG || DM111P_NAT || DM111P_IR || DM111PB_NO || DM111PB_NAT
#define SYS_BLANKSTATE_ID       25 
#endif

#if defined(SUPPORT_AUTO_DETECT_DEFAULT_PVC)
#define SYS_AUTO_DETECT_DEFAULT_PVC_ID       26
#endif

#if defined(SUPPORT_SERVICE_MODE)
#define SYS_SERVICE_MODE_ID 27
#endif

#if defined(RTA1025W_D46) || defined(RTA1335_D46) || defined(RTA1505W_D46)
#define SYS_CH_ADSL_NoiseMargin_ID 	28 //andy add to support CH request
#endif

#ifdef SUPPORT_AUTOPVC_COUNTRY_SELECTION
#define SYS_AUTOPVC_COUNTRY	29
#endif

// Values that are used in syscall.c
#define SYS_CMD_LEN        256

#define IP_TBL_COL_NUM     0
#define IP_TBL_COL_PKTS    1
#define IP_TBL_COL_BYTES   2
#define IP_TBL_COL_TARGET  3
#define IP_TBL_COL_PROT    4
#define IP_TBL_COL_OPT     5
#define IP_TBL_COL_IN      6
#define IP_TBL_COL_OUT     7
#define IP_TBL_COL_SRC     8
#define IP_TBL_COL_DST     9
#define IP_TBL_COL_MAX     10

#define UPNP_IP_ADDRESS    "239.255.255.250"


#if defined(__cplusplus)
extern "C" {
#endif
#define bcmSystem(cmd)		bcmSystemEx (cmd,1)
#define bcmSystemMute(cmd)	bcmSystemEx (cmd,0)
int bcmSystemEx (char *command, int printFlag);
int bcmSystemNoHang (char *command);
int bcmGetPid (char *command);
int bcmCreateDhcpCfg(char *ipAddr, char *mask, char *addrStart, char *addrEnd,
                     char *dns1, char *dns2, int leasedTime, int isForever, int protocol,
                     int enblNat, int enblFirewall, char *domain);
int bcmCreateIpExtDhcpCfg(char *lanAddr, char *mask, char *wanAddr, char *gwAddr, char *domain);
int bcmCreateLocalDhcpCfg(char *addr, char *mask, char *domain, char *startIp);
int bcmCreateResolvCfg(char *dns1, char *dns2);
int bcmCreateLoginCfg(char *, char *, char *, char *, char *, char *);
int bcmGetAdslStatus(void);
int bcmGetPppStatus(char *str, int len, char *devName);
int bcmGetDhcpcStatus(char *str, int len);
int bcmGetSystemStatus(char *str, int len);
int bcmSetSystemStatus(int status);
int bcmSetIpExtension(int ipExt);
int bcmGetIpExtension(char *str, int len);
void bcmDisplayLed(int status);
void bcmGetDns(char *dns);
void bcmGetDns2(char *dns);
void bcmGetDnsSettings(int *mode, char *primary, char *secondary);
void bcmRestartDnsProbe(void);
void bcmConfigDns(char *dns1, char *dns2, int dynamic);
void bcmRemoveDefaultGatewayByWanIf(char *wanIf);
void bcmGetDefaultGateway(char *gtwy, char *wanIf);
void wsnGetDefaultGateway(char *gtwy, char *wanIf);
int  bcmIsDefaultGatewayExisted(char *gw, char *wanIf);
int bcmIsDefaultGatewayIfName(char *wanIf);
void bcmSetAutoDefaultGateway(char *errMsg, int runcmd);
void bcmSetStaticDefaultGateway(char *gw, char *wanIf, char *errMsg);
void bcmKillAllApps(void);
void disconnectPPP(void);
void setWanLinkStatus(int up);
int bcmCheckInterfaceUp(char *devname);
int bcmSetIpExtInfo(char *wan, char *gateway, char *dns, char *wanIfname);
void bcmGetIpExtInfo(char *buf, int type);
int bcmGetIfcIndexByName(char *ifcName);
int bcmIsValidIfcName(char *ifcName);
char *bcmGetIfcNameById(int ifcId, char *ifcName);
void getPppoeServiceName(char *service, char *ifName);
void bcmGetDefaultRouteInterfaceName(char *ifcName);

void bcmSetConnTrackMax(void);
void bcmResetConnTrackTable(void);
void bcmHandleConnTrack(void);
void bcmInsertModules(char *path);
void bcmInsertModule(char *modName);
int bcmIsModuleInserted(char *modName);
int bcmRemoveIpTableRule(char *device, char *table, char *chain);
void bcmRemoveAllIpTableRules(char *device);
#if SUPPORT_TC
void bcmRemoveTrafficControlRules(unsigned short vpi, unsigned short vci,
                                                                      unsigned short conId, unsigned char protocol);
void bcmAddTrafficControlRules(unsigned short vpi, unsigned short vci,
                                                              unsigned short conId, unsigned char protocol);
#endif
int bcmRemoveRipIpTableRule(void);
int bcmRemoveUpnpIpTableRule(void);
void bcmInsertAllUpnpIpTableRules(void);
int bcmGetIntfNameSocket(int socketfd, char *intfname);
int bcmCheckEnable(char *appName, struct in_addr clntAddr);

int bcmRemoveEbTableRule(char *device, char *table, char *chain);
void bcmRemoveAllEbTableRules(char *device);
void bcmRemoveAllBrFilterRules(char *device);
int bcmRemoveAllEbTableFORWARDrule();

void parseStrInfo(char *info, char *var, char *val, int len);
void bcmConvertStrToShellStr(char *str, char *buf);
void bcmProcessMarkStrChars(char *str);
int  bcmIsMarkStrChar(char c);
void bcmSetSwVer(char *swVer);
void bcmGetSwVer(char *swVer, int size);
int isAccessFromLan(struct in_addr clntAddr);
void bcmRemoveModules(int lanIf, int reftpmodule);
int bcmWaitIntfExists(char *ifName);
int base64Encode(const void *inp, int insize, char **outptr);
void base64Decode(unsigned char *dest, char *src, int *rawLength);

/*Start Andy porting from 2.21.5*/
int getIfaceIpAddr(char *buff, char *ifaceName);
int OdmCreateDhcpMap(void);
int GetMASQIpTableRule(char *device, char *table, char *chain);
int GetTCPMSSIpTableRule(char *device, char *table, char *chain);
/*End Andy porting from 2.21.5*/
#ifdef BUILD_DOMAIN_LOCK
int wsnCheckStrTail(char *username, char *validDomain);
int wsnIsValidPppUser(char *pppUser);
#endif

#if VOXXXLOAD
#ifdef INCLUDE_VOIP_SIP
int jhGetIadPid();
#if defined(BT_METASWITCH_SIP) || defined(BT_ALCATEL_SIP)
int jhIsDspStarted();
#endif
#endif
int SysPstnVoipStatus(char *status);
#endif

#define BCM_PPPOE_CLIENT_STATE_PADO          0   /* waiting for PADO */
#define BCM_PPPOE_CLIENT_STATE_PADS          1   /* got PADO, waiting for PADS */
#define BCM_PPPOE_CLIENT_STATE_CONFIRMED     2   /* got PADS, session ID confirmed */
#define BCM_PPPOE_CLIENT_STATE_DOWN          3   /* totally down */
#define BCM_PPPOE_CLIENT_STATE_UP            4   /* totally up */
#define BCM_PPPOE_SERVICE_AVAILABLE          5   /* ppp service is available on the remote */

#define BCM_PPPOE_AUTH_FAILED                7

#define BCM_PRIMARY_DNS                      1
#define BCM_SECONDARY_DNS                    0

#if defined(__cplusplus)
}
#endif

#endif
