/* vi: set sw=4 ts=4: */
/*
 * Mini reboot implementation for busybox
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <sys/reboot.h>

#if VOXXXLOAD
#include <sys/un.h>   //PSTN status use
#endif


#include "busybox.h"
#include "init_shared.h"

#if VOXXXLOAD
/**************************************************************************
// Use for IAD only-----------Michael
// update PSTN VOIP switch handler
//
****************************************************************************/
int SysPstnVoipStatusReboot(char *status)
{
  #define PSTN_VOIP_NAME  "/var/toPstnVoip"
  int AsSockFd;
  struct sockaddr_un AsSockAddr;

  AsSockFd = socket(AF_UNIX, SOCK_STREAM, 0);
  if(AsSockFd < 0) return -2;

  AsSockAddr.sun_family = AF_UNIX;
  strcpy(AsSockAddr.sun_path, PSTN_VOIP_NAME);
  if(connect(AsSockFd, (struct sockaddr *) &AsSockAddr, sizeof(struct sockaddr_un)) < 0) {
    close(AsSockFd);
    return -1;
  }
  write(AsSockFd, status, 1);
  close(AsSockFd);
  return 0;
}
#endif

/************************************************************************************************/

extern int reboot_main(int argc, char **argv)
{
	char *delay; /* delay in seconds before rebooting */

#if VOXXXLOAD
    SysPstnVoipStatusReboot("B");  //Send call agent is down so switch to PSTN mode
    sleep(2);
#endif

	if(bb_getopt_ulflags(argc, argv, "d:", &delay)) {
		sleep(atoi(delay));
	}

#ifndef CONFIG_INIT
#ifndef RB_AUTOBOOT
#define RB_AUTOBOOT		0x01234567
#endif
	return(bb_shutdown_system(RB_AUTOBOOT));
#else
	return kill_init(SIGTERM);
#endif
}

/*
Local Variables:
c-file-style: "linux"
c-basic-offset: 4
tab-width: 4
End:
*/
