/* HTTP CLIENT */
/* Andy modify (2005/05/26) */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/param.h>
#include <sys/uio.h>
#include <unistd.h>

#define BUF_LEN 256*8                      

int main(int argc, char *argv[]){
    int s;                               
    struct hostent *servhost;            
    struct sockaddr_in server;           
    struct servent *service;             
    FILE *fp;                            
    char buf[BUF_LEN];
	int secs=0;
    char host[BUF_LEN] = "localhost";   
    char path[BUF_LEN] = "/";            
    unsigned short port = 0;
    int bytes=0;             

    if ( argc > 1 ){                    
        char host_path[BUF_LEN];

        if ( strlen(argv[1]) > BUF_LEN-1 ){
            fprintf(stderr, "URL unknown\n");
            return 1;
        }
                                         
                                         
        if ( strstr(argv[1], "http://") &&
             sscanf(argv[1], "http://%s", host_path) &&
             strcmp(argv[1], "http://" ) ){
            char *p;

            p = strchr(host_path, '/');  
            if ( p != NULL ){
                strcpy(path, p);        
                *p = '\0';
                strcpy(host, host_path); 
            } else {                    
                strcpy(host, host_path); 
            }

            p = strchr(host, ':');       
            if ( p != NULL ){
                port = atoi(p+1);        
                if ( port <= 0 ){        
                    port = 80;           
                }
                *p = '\0';
            }
        } else {
            fprintf(stderr, "URL error http://host/path \n");
            return 1;
        }
    }

    printf("http://%s%s \n\n",host, path);

                                
    servhost = gethostbyname(host);
    if ( servhost == NULL ){
        fprintf(stderr, "[%s]\n", host);
        return 0;
    }

    bzero((char *)&server, sizeof(server));     

    server.sin_family = AF_INET;

                                               
    bcopy(servhost->h_addr, (char *)&server.sin_addr, servhost->h_length);

    if ( port != 0 ){                          
        server.sin_port = htons(port);
    } else {                                   
        service = getservbyname("http", "tcp");
        if ( service != NULL ){                
            server.sin_port = service->s_port;
        } else {                               
            server.sin_port = htons(80);
        }
    }
                                
    if ( ( s = socket(AF_INET, SOCK_STREAM, 0) ) < 0 ){
        fprintf(stderr, "can't create socket\n");
        return 1;
    }
                                
    if ( connect(s, (struct sockaddr *)&server, sizeof(server)) == -1 ){
        fprintf(stderr, "connect fail\n");
        return 1;
    }
                                
    //fp = fdopen(s, "r+");
    //if ( fp == NULL ){
    //   fprintf(stderr, "fdopen fail\n");
    //    return 1;
   	// }
                                
    //setvbuf(fp, NULL, _IONBF, 0);
    
    //fprintf(fp, "GET %s HTTP/1.0\r\n", path);
    //fprintf(fp, "Host: %s:%d\r\n", host, port);
    //fprintf(fp, "\r\n");

	/* Build request buffer, starting with the GET. */
	buf[0]='\0';
    bytes = snprintf( buf, sizeof(buf), "GET %s HTTP/1.0\r\n", path );
    bytes += snprintf( &buf[bytes], sizeof(buf) - bytes, "Host: %s:%d\r\n", host, port );
    bytes += snprintf( &buf[bytes], sizeof(buf) - bytes, "%s", "\r\n" );
	(void) write( s, buf, bytes );
	

#if 1
	fp = fdopen(s, "r+");
    if ( fp == NULL ){
        fprintf(stderr, "fdopen fail\n");
        return 1;
    }
    while ( fgets(buf, sizeof(buf), fp) ){
		printf("%s", buf);
		if (strcmp(buf,"\r\n")==0){
			printf("This line is http header last line\n");
			break;
		}
	}
	secs = time(NULL);
	printf("1...secs=%d\n",secs);
	while ( fgets(buf, sizeof(buf), fp) ){
		//printf("%s", buf);
	}
	secs = time(NULL);
	printf("2...secs=%d\n",secs);
#else
	while ( read( s, buf, sizeof(buf)) ){
		printf("%s", buf);
		if (strncmp(buf,"\r\n", 2)==0){
			printf("This line is http header last line\n");
			break;
		}
	}
	bytes =0;
	int counter =0;
	secs = time(NULL);
	printf("1...secs=%d\n",secs);
	while ( (bytes=read( s, buf, sizeof(buf))) ){
		//printf("%s", buf);
		counter = counter + bytes;
	}
	secs = time(NULL);
	printf("2...secs=%d\n",secs);
	printf("bytes=%d\n",byte);
#endif
    
    fclose(fp);
    close(s);

    return 0;
}
